import { arc } from 'd3';

export const Marks = ({
  data,
  xScale,
  yScale,
  xValue,
  yValue,
  tooltipFormat
}) => {

  let totalPopulation = 0;
	console.log(data);
	data.forEach(element => {
    	totalPopulation += element.Population;
  });
  
  let startPercent = 0;
  let sizePercent = 0.1; // in percentage
  // Total circum is 2pi
  let percentToRadian = Math.PI * 2;
  
  
  let colors = ["#F00000", "#0F0000", "#00F000", "#000F00", "#0000F0", "#00000F", "#FF00FF", "#00FFFF", "#FFFF00", "#000000"];
  let colorIndex = -1;
  
  return data.map(d => {
    // increment starting at -1
    colorIndex++;
    
    // calculate piece size
    console.log(d.Population);
    console.log(sizePercent);
    console.log(startPercent);
    sizePercent = d.Population / totalPopulation;
    
    // declare function with params
    const mouthArc = arc()
    	.innerRadius(80)
			.outerRadius(120)
  		.startAngle(startPercent * percentToRadian)
			.endAngle((startPercent * percentToRadian) + (sizePercent * percentToRadian));
  
    let textX = 140*Math.sin(startPercent*percentToRadian);
    let textY = 140*Math.cos(startPercent*percentToRadian);
    let offsetX = -30;
    let offsetY = 160;
    
    // update start angle
    startPercent = startPercent + sizePercent;
    
    // return the value
    return <g
      >
        <path
          d={mouthArc()} 
          fill={colors[colorIndex]}
          transform={`translate(${offsetX},${offsetY})`}
      />
      <text
        transform={`translate(${offsetX+textX},${offsetY+textY})`}
      >
        {d.Population}
      </text>
      </g>;
      
  });
  
};
